//
// CScanDir.cpp
//+
//	Scan directory class implementation
//-
//	rev 11/09/98 gls
//

#include "stdafx.h"
#include "CScanDir.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ////////////////////////////////////////////////////////////
// CScanDir

CScanDir::CScanDir()
{
}

CScanDir::~CScanDir()
{
}

// ////////////////////////////////////////////////////////////

	//
	//	local callback function template
	//
	static	BOOL __EnumScan( void *pContext, CFileFind *pFind )
	{
		CScanDir	*pScan = (CScanDir *)pContext;	// cast to proper format

        CString sPath = pFind->GetFilePath();

		if( pFind->IsDirectory() )
            {
            if( !pFind->IsDots() )	// don't add . or ..
                {
                }
            }
        else
            {
            }


		return( TRUE );
	}

//
//	Scan for specified files
//
BOOL	CScanDir::Scan( LPCSTR pszFileSpec )
{
	ASSERT( pszFileSpec != NULL );

	BOOL	fSuccess = ScanEnum( pszFileSpec, __EnumScan, this );

	return( fSuccess ? TRUE : FALSE );
}
// ////////////////////////////////////////////////////////////
//
//	Generic directory scanning with callback processing and
//	calls to the virtual functions.
//
BOOL	CScanDir::ScanEnum( LPCSTR pszFileSpec,
				BOOL (*pFunc)( void *pContext, CFileFind *pFind ),
				void *pContextCallback )
{
    ASSERT( pszFileSpec );

    m_rgsFile.RemoveAll();          // remove any previous
    m_rgsDir.RemoveAll();

	BOOL	fSuccess = TRUE;

    CFileFind   Find;
    BOOL    fFound = Find.FindFile( pszFileSpec );

    while( fFound )
        {
        fFound = Find.FindNextFile();

		//
		//	First, give the callback a chance to look
		//	at the entry.
		//
		if( !(*pFunc)( pContextCallback, &Find ) )
			{
			fSuccess = FALSE;
			break;					// false return kicks us out!
			}

		//
		//	Now, the virtual functions
		//
        CString sPath = Find.GetFilePath();

        if( Find.IsDirectory() )
            {
            if( !Find.IsDots() )		// don't add . or ..
                {
                m_rgsDir.Add( sPath );	// add to local list
                }
			if( !OnEnumDir( sPath ) )	// call to virtual function
				{
				fSuccess = FALSE;
				break;
				}
            }
        else
            {
            m_rgsFile.Add( sPath );		// add to local list
			if( !OnEnumFile( sPath ) )	// call to virtual function
				{
				fSuccess = FALSE;
				break;
				}
            }
        }

	return( fSuccess );
}
// ////////////////////////////////////////////////////////////
// ////////////////////////////////////////////////////////////
// ////////////////////////////////////////////////////////////
